<template>
    <div class="slds-box slds-theme_default main-container">
        <div class="slds-grid slds-wrap slds-gutters">
            <div class="slds-col slds-size_1-of-2">
                <div class="slds-grid slds-grid_vertical">
                    <div class="slds-col">
                        <label>Original</label>
                    </div>
                    <div class="slds-col" style="height: 28rem;">
                        <canvas data-id="canvasOriginal" class="slds-align_absolute-center" onmousemove={handleCanvasMouseMove}></canvas>
                    </div>
                    <div class="slds-col slds-align_absolute-center">
                        <lightning-input class="slds-align_absolute-center" type="file" accept="image/png, image/jpeg" onchange={handleInputChange}></lightning-input>
                    </div>
                </div>
            </div>
            <div class="slds-col slds-size_1-of-2">
                <div class="slds-grid slds-grid_vertical">
                    <div class="slds-col">
                        <label>Changed</label>
                    </div>
                    <div class="slds-col" style="height: 28rem;">
                        <canvas data-id="canvasChanged" class="slds-align_absolute-center" onmousemove={handleCanvasMouseMove}></canvas>
                    </div>
                    <div class="slds-col">
                        <button class="slds-button slds-button_brand slds-align_absolute-center slds-m-top_large" onclick={downloadImage}>Download</button>
                    </div>
                </div>
            </div>
        </div>
    </div>
    <div class="slds-box slds-theme_default secondary-container">
        <div class="slds-grid slds-wrap">
            <div class="slds-col slds-size_6-of-12">
                <div class="slds-grid slds-grid_vertical">
                    <div class="slds-col">
                        <label class="slds-text-heading_medium">Image Properties</label>
                    </div>
                    <div class="slds-col slds-m-top_medium">
                        <label class="slds-text-heading_small">RGB ({RGB.R}, {RGB.G}, {RGB.B})</label>
                    </div>
                    <div class="slds-col slds-m-top_xx-small">
                        <label class="slds-text-heading_small">CMYK ({CMYK.C}%, {CMYK.M}%, {CMYK.Y}%, {CMYK.K}%)</label>
                    </div>
                    <div class="slds-col slds-m-top_xx-small">
                        <label class="slds-text-heading_small">HSL ({HSL.H}, {HSL.S}%, {HSL.L}%)</label>
                    </div>
                </div>
            </div>
            <div class="slds-col slds-size_5-of-12 slds-m-top_large">
                <label class="slds-text-heading_medium">Grey Color Lightness</label>
                <lightning-slider class="slds-text-heading_small" value={lightness} onchange={handleSliderChange}></lightning-slider>
            </div>
            <div class="slds-col slds-size_1-of-12">
                <button class="slds-button slds-button_icon slds-button_icon-inverse slds-float_right help" onclick={handleModal}>
                    <lightning-icon class="slds-icon-text-light" icon-name="action:question_post_action" size="small" 
                    style="background-color: #f3f3f3" alternative-text="Help" title="Help">
                        <label>Help</label>
                    </lightning-icon>
                </button>
                <c-modal-window is-modal-open={isModalOpen} onclosemodal={handleModal} header-text="Help" 
                body-text="First, upload you image. Then you can change the brightness of grey color. 
                Once you are done download your result.">
                </c-modal-window>
            </div>
        </div>
    </div>
</template>